<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetTerminalsForIntakeResponse StructType
 * @subpackage Structs
 */
class SetTerminalsForIntakeResponse extends AbstractStructBase
{
    /**
     * The ResultCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ResultCode;
    /**
     * The SetTerminalsForIntakeResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SetTerminalsForIntakeResponse
     */
    public $SetTerminalsForIntakeResult;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString1
     */
    public $Errors;
    /**
     * Constructor method for SetTerminalsForIntakeResponse
     * @uses SetTerminalsForIntakeResponse::setResultCode()
     * @uses SetTerminalsForIntakeResponse::setSetTerminalsForIntakeResult()
     * @uses SetTerminalsForIntakeResponse::setErrors()
     * @param int $resultCode
     * @param \StructType\SetTerminalsForIntakeResponse $setTerminalsForIntakeResult
     * @param \ArrayType\ArrayOfString1 $errors
     */
    public function __construct($resultCode = null, \StructType\SetTerminalsForIntakeResponse $setTerminalsForIntakeResult = null, \ArrayType\ArrayOfString1 $errors = null)
    {
        $this
            ->setResultCode($resultCode)
            ->setSetTerminalsForIntakeResult($setTerminalsForIntakeResult)
            ->setErrors($errors);
    }
    /**
     * Get ResultCode value
     * @return int
     */
    public function getResultCode()
    {
        return $this->ResultCode;
    }
    /**
     * Set ResultCode value
     * @param int $resultCode
     * @return \StructType\SetTerminalsForIntakeResponse
     */
    public function setResultCode($resultCode = null)
    {
        // validation for constraint: int
        if (!is_null($resultCode) && !(is_int($resultCode) || ctype_digit($resultCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($resultCode, true), gettype($resultCode)), __LINE__);
        }
        $this->ResultCode = $resultCode;
        return $this;
    }
    /**
     * Get SetTerminalsForIntakeResult value
     * @return \StructType\SetTerminalsForIntakeResponse|null
     */
    public function getSetTerminalsForIntakeResult()
    {
        return $this->SetTerminalsForIntakeResult;
    }
    /**
     * Set SetTerminalsForIntakeResult value
     * @param \StructType\SetTerminalsForIntakeResponse $setTerminalsForIntakeResult
     * @return \StructType\SetTerminalsForIntakeResponse
     */
    public function setSetTerminalsForIntakeResult(\StructType\SetTerminalsForIntakeResponse $setTerminalsForIntakeResult = null)
    {
        $this->SetTerminalsForIntakeResult = $setTerminalsForIntakeResult;
        return $this;
    }
    /**
     * Get Errors value
     * @return \ArrayType\ArrayOfString1|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \ArrayType\ArrayOfString1 $errors
     * @return \StructType\SetTerminalsForIntakeResponse
     */
    public function setErrors(\ArrayType\ArrayOfString1 $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetTerminalsForIntakeResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
